theory Demo13
  imports First_Order_Terms.Unification
begin

text \<open>
The term \<open>t = f(x,y)\<close>
\<close>
term "Fun ''f'' [Var ''x'', Var ''y'']"

text \<open>
The substitution \<open>\<sigma> = {y \<mapsto> g(b)}\<close>
\<close>
term "subst ''y'' (Fun ''g'' [Fun ''b'' []])"

text \<open>
Applying the substitution \<open>\<sigma>\<close> to the term \<open>t\<close>
(often written \<open>t\<sigma>\<close>).
\<close>
term "Fun ''f'' [Var ''x'', Var ''y''] \<cdot> subst ''y'' (Fun ''g'' [Fun ''b'' []])"
value "Fun ''f'' [Var ''x'', Var ''y''] \<cdot> subst ''y'' (Fun ''g'' [Fun ''b'' []])"

text \<open>
Try to compute most general unifier of terms \<open>f(a,x)\<close> and \<open>f(x,b)\<close>.
\<close>
value "mgu (Fun ''f'' [Fun ''a'' [], Var ''x''])
          (Fun ''f'' [Var ''x'',     Fun ''b'' []])"
text \<open>
Once again with different variables \<open>f(a,x)\<close> and \<open>f(y,b)\<close>.
(Using @{const unify} instead of @{const mgu} since substitutions are
functions and functions cannot be printed.
\<close>
value "unify [(Fun ''f'' [Fun ''a'' [], Var ''x''],
               Fun ''f'' [Var ''y'',     Fun ''b'' []])] []"

end